Unit ef12r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, EFFR_p, EFRS_p, EFUS_p, EFUF_p, EFSL_p, EFUD_p, EFRD_p;

procedure ef12r(var SX :Array of Real; var SY :Array of Real; N :Integer;
                M :Integer; var A :Array of Real; var U :Array of Real;
                var F :Array of Real; var P :Array of Real; P1 :Real;
                P2 :Real; P3 :Real; EPS :Real; var HX :Array of Real;
                var W :Array of Real; L :Integer);

implementation

procedure ef12r(var SX :Array of Real; var SY :Array of Real; N :Integer;
                M :Integer; var A :Array of Real; var U :Array of Real;
                var F :Array of Real; var P :Array of Real; P1 :Real;
                P2 :Real; P3 :Real; EPS :Real; var HX :Array of Real;
                var W :Array of Real; L :Integer);
var
I,J,K,NITER,IEXIT :Integer;
RMIN1,RMIN,R,F1,S,SR,RR,HH,QQ,Q,H1 :Real;
H :Array [0..49] of Real;
label
_1,_2,_3,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
RMIN1 := 1.0;
case L of
 1: goto _1;
 2: goto _7;
 3: goto _2;
end;
_1:
RMIN := RMIN1;
RMIN1 := RMIN/2.0;
if ( RMIN1 > 0. ) 
 then goto _1;
EFFR(A,M,N,P,SX,SY,F,P1,P2,P3,W[0+0*N],W[0+1*N],W[0+2*N],H);
EFRS(A,M,N,W[0+0*N],W[0+1*N],W[0+2*N],H);
EFUS(A,M,N,W[0+3*N],W[0+4*N],H);
W[(N-1)+2*N] := RMIN;
goto _6;
_2:
for I:=1 to M do
 begin
  F[I-1] := F[I-1]*P[I-1];
_3:
 end;
_6:
EFUF(A,M,N,F,H);
_7:
RMIN := W[(N-1)+2*N];
RMIN1 := RMIN+RMIN;
F1 := F[0];
R := F1*F1;
S := IntPower(F1*W[0+3*N],2);
for I:=2 to N do
 begin
  F1 := F[I-1];
  R := R+F1*F1;
_8:
  S := S+IntPower(W[(I-1)+3*N]*F1+W[(I-2)+4*N]*F[I-2],2);
 end;
SR := Sqrt(R);
RR := SR*EPS;
H[0] := SR;
H[1] := 0.0;
H[2] := 0.0;
H[3] := R;
H[4] := 1.E+18;
H[5] := 0.0;
H[6] := 1.0;
NITER := 0;
IEXIT := -1;
HH := SR;
QQ := H[4];
for I:=1 to N do
 begin
_9:
  U[I-1] := 0.0;
 end;
if ( EPS >= 1. ) 
 then goto _14;
Q := (EPS/(1.0-EPS))*(S/R);
if ( Q = 0. ) 
 then Q := RMIN;
_10:
EFSL(W[0+3*N],W[0+4*N],M,N,Q,F,U,H,W[0+5*N],W[0+6*N],W[0+7*N]);
H1 := H[0];
H[4] := Q;
H[5] := H[5]+1.0;
H[6] := H1/SR;
if ( IEXIT = 1 ) 
 then goto _13;
if ( HH >= H1 ) 
 then goto _11;
IEXIT := 1;
Q := QQ;
goto _10;
_11:
if ( RR*1.001 >= H1 ) 
 then goto _13;
if ( Q <= RMIN1 ) 
 then goto _13;
HH := H1;
QQ := Q;
S := 0.0;
for I:=1 to N do
 begin
_12:
  S := S+U[I-1]*Q*W[(I-1)+7*N];
 end;
R := (H1/RR-1.0)*H1*(H1/S);
if ( R <= 0.5 ) 
 then NITER := NITER+1;
if ( R <= 0.5 ) and ( H[5] >= 10. ) and ( NITER > 5 ) 
 then R := 1.0;
Q := Q/(1.0+R);
if ( Q = 0. ) 
 then Q := RMIN;
goto _10;
_13:
EFUD(A,M,N,U,H);
EFRD(U,N,W[0+0*N],W[0+1*N],W[0+2*N],SX,H);
{       (6)=(6)+NIR*0.01 }
_14:
for I:=1 to 7 do
 begin
  HX[I-1] := H[I-1];
_15:
 end;
end;

end.
