Unit efsl_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure efsl(var B :Array of Real; var C :Array of Real; M :Integer;
               N :Integer; Q :Real; var F :Array of Real;
               var U :Array of Real; var H :Array of Real;
               var V :Array of Real; var W :Array of Real;
               var W1 :Array of Real);

implementation

procedure efsl(var B :Array of Real; var C :Array of Real; M :Integer;
               N :Integer; Q :Real; var F :Array of Real;
               var U :Array of Real; var H :Array of Real;
               var V :Array of Real; var W :Array of Real;
               var W1 :Array of Real);
var
I,J,K,L,L1 :Integer;
R,R1,R2,T,T1,T2,S,S1,S2,S3,S4,S5,S6,S7,S8 :Real;
const
ZERO :Real = 0.0;
IDATE :Integer = 240184;
label
_1,_2,_3,_4,_5,_6,_66,_7,_8,_9,_10;
begin
if ( M < N) or (N <= 2) or (Q < ZERO ) 
 then goto _10;
S := ZERO;
L := N+1;
_1:
L := L-1;
if ( B[L-1] = S) and (C[L-2] = S) and (L > 3 ) 
 then goto _1;
L1 := L+1;
if ( L-M ) < 0
 then goto _2
 else if ( L-M ) > 0
       then goto _10
       else goto _4;
_2:
for I:=L1 to M do
 begin
  T1 := F[I-1];
_3:
  S := S+T1*T1;
 end;
_4:
T := B[0];
R := EMax1(Sqrt(Q+T*T),Abs(T));
V[0] := R;
T2 := C[0];
R2 := T2*(T/R);
W[0] := R2;
S2 := F[0];
R1 := T*S2/R;
U[0] := R1;
S5 := S2*S2;
for I:=2 to L do
 begin
  T := B[I-1];
  T1 := T2;
  T2 := C[I-1];
  S1 := S2;
  S2 := F[I-1];
  R := EMax1(ZERO,(T1-R2)*(T1+R2));
  R := EMax1(Sqrt(T*T+R+Q),Abs(T));
  R1 := (T*S2+T1*S1-R1*R2)/R;
  U[I-1] := R1;
  V[I-1] := R;
  R2 := T2*(T/R);
  W[I-1] := R2;
_5:
  S5 := S5+S2*S2;
 end;
R2 := Sqrt(Q);
if ( L1 > N ) 
 then goto _66;
for I:=L1 to N do
 begin
  U[I-1] := ZERO;
  V[I-1] := R2;
  W[I-1] := ZERO;
_6:
  W1[I-1] := ZERO;
 end;
_66:
R := R1/R;
U[L-1] := R;
R2 := R*T-S2;
S1 := R2*R2;
S3 := R*R;
S7 := R*T*F[L-1];
S8 := R*T*Q*R*T;
for I:=2 to L do
 begin
  J := L1-I;
  R1 := R;
  R := (U[J-1]-R*W[J-1])/V[J-1];
  U[J-1] := R;
  R2 := R*B[J-1]+R1*C[J-1];
  S7 := S7+R2*F[J-1];
  S8 := S8+R2*Q*R2;
  R2 := R2-F[J-1];
  S1 := S1+R2*R2;
_7:
  S3 := S3+R*R;
 end;
R := Q*R/V[0];
W1[0] := R;
for K:=2 to L do
 begin
  R := (Q*U[K-1]-R*W[K-2])/V[K-1];
_8:
  W1[K-1] := R;
 end;
R := R/V[L-1];
W1[L-1] := R;
S2 := R*R;
S4 := R*U[L-1];
S6 := IntPower((R+U[L-1])*V[L-1]-F[L-1],2);
for I:=2 to L do
 begin
  J := L1-I;
  R := (W1[J-1]-R*W[J-1])/V[J-1];
  W1[J-1] := R;
  S2 := S2+R*R;
  S4 := S4+R*U[J-1];
  R1 := (W1[J+0]+U[J+0])*W[J-1];
_9:
  S6 := S6+IntPower((R+U[J-1])*V[J-1]+R1-F[J-1],2);
 end;
H[0] := Sqrt(S1+S);
H[1] := Sqrt(S2);
H[2] := Sqrt(S3);
H[3] := S1+S+Q*S3;
H[4] := Sqrt(S6+S)/H[0];
H[5] := H[0]/Sqrt(S5+S);
H[6] := Q;
H[15] := H[2]/Sqrt(S5+S);
H[16] := (L);
H[17] := S4;
H[21] := S7-S5-S;
H[22] := (S8-S7*Q)/S8;
H[23] := Sqrt(EMax1(ZERO,S1-(S8-Q*S7)*H[22]/Q+S));
H[45] := (IDATE);
_10:
end;

end.
