Unit efus_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure efus(var A :Array of Real; M :Integer; N :Integer;
               var B :Array of Real; var C :Array of Real;
               var H :Array of Real);

implementation

procedure efus(var A :Array of Real; M :Integer; N :Integer;
               var B :Array of Real; var C :Array of Real;
               var H :Array of Real);
var
I,J,K,L,II,JJ,JN,I1,J1,ISWTCH :Integer;
R1,R2,R3,R4,R5,R6,SUM,RMIN,RNORM :Real;
RD,RD2,DS1,DS2,DMIN :Extended;
const
ZERO :Real = 0.0;
DZERO :Extended = 0.0e0;
ONE :Real = 1.0;
TWO :Real = 2.0;
IDATE :Integer = 60183;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,_20,
_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32;
begin
RNORM := ZERO;
if ( M < N) or (N <= 2 ) 
 then goto _30;
RMIN := ONE;
_1:
RMIN := RMIN/TWO;
if ( ONE < (ONE+RMIN)) and (RMIN > ZERO ) 
 then goto _1;
DMIN := IntPower(RMIN,2);
DS1 := DZERO;
DS2 := DZERO;
SUM := ZERO;
ISWTCH := 1;
R5 := ZERO;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    R6 := Abs(A[(I-1)+(J-1)*M]);
    if ( R6 > R5 ) 
     then R5 := R6;
_2:
   end;
 end;
RNORM := ONE;
if ( R5 = ZERO ) 
 then goto _32;
if ( ((R5*RMIN)/128.0)*128.*RMIN > ZERO ) 
 then goto _4;
if ( R5 > ONE ) 
 then goto _4;
if ( (R5/128.0) = ZERO ) 
 then R5 := R5*128.0;
ISWTCH := Trunc( (Trunc(-Ln(R5)/Ln(TWO))+1)/2 );
RNORM := Power(TWO,ISWTCH);
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    A[(I-1)+(J-1)*M] := (A[(I-1)+(J-1)*M]*RNORM)*RNORM;
_3:
   end;
 end;
_4:
H[31] := RMIN;
H[32] := RNORM;
H[43] := (IDATE);
JJ := 1;
JN := 2;
C[N-1] := ZERO;
_5:
RD2 := DZERO;
for K:=JJ to M do
 begin
  RD := A[(K-1)+(JJ-1)*M];
_6:
  RD2 := RD2+RD*RD;
 end;
_7:
R2 := RD2;
DS1 := DS1+RD2;
DS2 := DS2-RD2;
J := JJ;
JJ := JN;
JN := JJ+1;
if ( DS2 < DMIN*DS1) and (ISWTCH < 0 ) 
 then goto _28;
R4 := DS1;
R4 := (RMIN*R4)*RMIN;
if ( R2 > R4) or (ISWTCH < 0 ) 
 then goto _9;
SUM := R2;
for I1:=J to M do
 begin
  for J1:=JJ to N do
   begin
_8:
    SUM := SUM+IntPower(A[(I1-1)+(J1-1)*M],2);
   end;
 end;
DS2 := SUM;
ISWTCH := -1;
H[33] := (J);
H[34] := (DS1);
H[35] := SUM;
if ( DS2 <= DMIN*DS1 ) 
 then goto _28;
_9:
R1 := A[(J-1)+(J-1)*M];
R3 := Sign(Sqrt(R2),R1);
B[J-1] := -R3;
L := JJ-N;
if ( R2 ) < 0
 then goto _30
 else if ( R2 ) > 0
       then goto _10
       else goto _16;
_10:
R1 := Sqrt(ONE+R1/R3);
R2 := ONE/(R3*R1);
A[(J-1)+(J-1)*M] := R1;
for I:=JJ to M do
 begin
_11:
  A[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M]*R2;
 end;
if ( L ) < 0
 then goto _12
 else if ( L ) > 0
       then goto _30
       else goto _12;
_12:
RD2 := DZERO;
for K:=JJ to N do
 begin
  R3 := ZERO;
  for I:=J to M do
   begin
_13:
    R3 := R3+A[(I-1)+(J-1)*M]*A[(I-1)+(K-1)*M];
   end;
  R2 := A[(J-1)+(K-1)*M]-R1*R3;
  A[(J-1)+(K-1)*M] := R2;
  RD := R2;
  RD2 := RD2+RD*R2;
  for I:=JJ to M do
   begin
_14:
    A[(I-1)+(K-1)*M] := A[(I-1)+(K-1)*M]-R3*A[(I-1)+(J-1)*M];
   end;
 end;
_15:
if ( L ) < 0
 then goto _21
 else if ( L ) > 0
       then goto _30
       else goto _18;
_16:
for II:=J to M do
 begin
_17:
  A[(II-1)+(J-1)*M] := ZERO;
 end;
if ( L ) < 0
 then goto _19
 else if ( L ) > 0
       then goto _30
       else goto _18;
_18:
R3 := A[(N-2)+(N-1)*M];
R4 := DS1;
R4 := (RMIN*R4)*RMIN;
R3 := R3*R3;
if ( R3 <= R4) and (M <= N ) 
 then A[(N-2)+(N-1)*M] := ZERO;
R3 := A[(N-1)+(N-1)*M];
R3 := R3*R3;
if ( R3 <= R4) and (M <= N ) 
 then A[(N-1)+(N-1)*M] := ZERO;
C[N-2] := A[(N-2)+(N-1)*M];
B[N-1] := A[(N-1)+(N-1)*M];
if ( M-N ) < 0
 then goto _30
 else if ( M-N ) > 0
       then goto _5
       else goto _30;
_19:
RD2 := DZERO;
for K:=JJ to N do
 begin
  RD := A[(J-1)+(K-1)*M];
_20:
  RD2 := RD2+RD*RD;
 end;
_21:
R2 := RD2;
DS1 := DS1+RD2;
DS2 := DS2-RD2;
R1 := A[(J-1)+(JJ-1)*M];
R3 := Sign(Sqrt(R2),R1);
C[J-1] := -R3;
if ( R2 ) < 0
 then goto _30
 else if ( R2 ) > 0
       then goto _24
       else goto _22;
_22:
for II:=JJ to N do
 begin
_23:
  A[(J-1)+(II-1)*M] := ZERO;
 end;
goto _5;
_24:
R1 := Sqrt(ONE+R1/R3);
R2 := ONE/(R3*R1);
A[(J-1)+(JJ-1)*M] := R1;
for K:=JN to N do
 begin
_25:
  A[(J-1)+(K-1)*M] := A[(J-1)+(K-1)*M]*R2;
 end;
RD2 := DZERO;
for I:=JJ to M do
 begin
  R3 := ZERO;
  for K:=JJ to N do
   begin
_26:
    R3 := R3+A[(J-1)+(K-1)*M]*A[(I-1)+(K-1)*M];
   end;
  R2 := A[(I-1)+(JJ-1)*M]-R1*R3;
  A[(I-1)+(JJ-1)*M] := R2;
  RD := R2;
  RD2 := RD2+RD*R2;
  for K:=JN to N do
   begin
_27:
    A[(I-1)+(K-1)*M] := A[(I-1)+(K-1)*M]-R3*A[(J-1)+(K-1)*M];
   end;
 end;
goto _7;
_28:
for J1:=J to N do
 begin
  B[J1-1] := ZERO;
  C[J1-1] := ZERO;
  for I1:=J to M do
   begin
_29:
    A[(I1-1)+(J1-1)*M] := ZERO;
   end;
 end;
_30:
if ( RNORM = ONE ) 
 then goto _32;
RNORM := ONE/RNORM;
for J:=1 to N do
 begin
  B[J-1] := (B[J-1]*RNORM)*RNORM;
  C[J-1] := (C[J-1]*RNORM)*RNORM;
_31:
 end;
_32:
end;

end.
